#!/bin/bash

RELEASE="gnome-3-8"
DL_URL="https://l10n.gnome.org/languages"
WGET_OPTS="--no-check-certificate -q"

##
# Get all language codes from DL
##

#wget http://l10n.gnome.org/releases/$RELEASE/ -O temp.html

#grep doc temp.html |awk -F "/" {'print $3'} >>languages

#rm temp.html

#LINGUAS=`cat languages | tr '\n' ' '`

#echo $LINGUAS

#rm languages


LINGUAS="ar bg bn_IN ca cs da de el en_GB es eu fa fi fr gl gu hi hu id it ja ko lv mk nds nl oc pa pl pt pt_BR ro ru sl sr sr@latin sv ta te th tr uk vi zh_CN zh_HK zh_TW"
#LINGUAS="es"


##
# Get all the documentation PO file from Damned-Lies, using languages with at least one string in DL
##
for i in `echo $LINGUAS`
do
	echo
	echo -e "Downloading PO files for:\e[1;32m $i \e[0m"
	mkdir $i

	wget $WGET_OPTS $DL_URL/$i/$RELEASE/doc.tar.gz -O $i/$i.tar.gz ; tar -zxf $i/$i.tar.gz -C $i ; rm $i/$i.tar.gz
	wget $WGET_OPTS $DL_URL/$i/external-deps/doc.tar.gz -O $i/external.tar.gz && tar -zxf $i/external.tar.gz -C $i && rm $i/external.tar.gz
	wget $WGET_OPTS $DL_URL/$i/gnome-office/doc.tar.gz -O $i/office.tar.gz && tar -zxf $i/office.tar.gz -C $i && rm $i/office.tar.gz
	wget $WGET_OPTS $DL_URL/$i/gnome-infrastructure/doc.tar.gz -O $i/infraestructure.tar.gz && tar -zxf $i/infraestructure.tar.gz -C $i && rm $i/infraestructure.tar.gz
	wget $WGET_OPTS $DL_URL/$i/gnome-gimp/doc.tar.gz -O $i/gimp.tar.gz && tar -zxf $i/gimp.tar.gz -C $i && rm $i/gimp.tar.gz
	wget $WGET_OPTS $DL_URL/$i/gnome-extras/doc.tar.gz -O $i/extras.tar.gz && tar -zxf $i/extras.tar.gz -C $i && rm $i/extras.tar.gz
done

##
# Check PO files with gtxml and create a report file for each language
##
echo -e "\nGenerating report..."

for j in `echo $LINGUAS`
do
	gtxml $j/*.po >>$j-report.txt
	rm -rf $j
done

##
# Remove files with zero size (language with no errors) and pack all reports in a .tar.gz file, ready to send to i18n mail list
##
find . -size 0 -exec rm {} \;

tar -zcf gtxml-doc-reports.tar.gz *.txt
rm *.txt

echo -e "\nReport generated succesfully. You can find it at\e[1;32m «gtxml-doc-reports.tar.gz»\e[0m"

